//---------------------------------------------------------------------------
#include <vcl.h>
#include <mmsystem.h>
#include <stdlib.h>
#pragma hdrstop

#include "Common.h"
#include "MovingCharacter.h"
#include "MainFrm.h"
#include "GameField.h"
#include "SystemAdapter.h"


//---------------------------------------------------------------------------
GameField::GameField(int id_num,MovingCharacter *m)
{
    id = id_num;
	mov = m;  // Ή cMovingNXݒ

    syori_flg = false;
	ojamanum  =
    attacknum =
    wkkill    =
    killnum   =
    rensa     =
    score = bonus = 0;
    itemCount = 0;
    itemInterval = 10;

    attackPower = 0;

    isOjamaExisting = isGameOver = false;
    wins = 0;

    int i,j;
    for (i=0;i<=mainx;i++)
      for (j=0;j<=mainy+4;j++) {
        	tumiage_chr[i][j]=0 ;
     		syometu_flg[i][j]=false;
     }


}

// 


void GameField::pileup()
{

    lblOjama->Caption=(IntToStr(ojamanum));


    waveflg=false;

	// Xs[hĂ߂肱񂾂Ƃ̈ʒu␳
    mov->calculateXYPosition();
    if ( (mov->posy1 <= mov->stackedHeight[mov->posx1])||(mov->posy2 <= mov->stackedHeight[mov->posx2]))
    {
    	if (mov->posx1 != mov->posx2) {  // 

        	if (mov->stackedHeight[mov->posx1] >= mov->stackedHeight[mov->posx2] ) {
        		mov->posy1 = mov->stackedHeight[mov->posx1] +1;
        		mov->posy2 = mov->stackedHeight[mov->posx1] +1;
            }
            else {
        		mov->posy1 = mov->stackedHeight[mov->posx2] +1;
        		mov->posy2 = mov->stackedHeight[mov->posx2] +1;
            }
        }

        else if (mov->posy2 > mov->posy1 ) {  //Q
        	mov->posy1 = mov->stackedHeight[mov->posx1] +1;
        	mov->posy2 = mov->posy1 + 1;
        }
        else if (mov->posy1 > mov->posy2 ) {
        	mov->posy2 = mov->stackedHeight[mov->posx2] +1;
        	mov->posy1 = mov->posy2 + 1;
        }
        
    }



    tumiage_chr[mov->posx1][mov->posy1]=mov->kind1;
    tumiage_chr[mov->posx2][mov->posy2]=mov->kind2;

    mov->eraseMoving();


    sysAdapter->drawStackedCharacter(this);
    jyuryoku_check();
    calculateStackedCharacterHeight();

}


// 

// 񑀍L󒆂ɕĂ邩ǂ𒲂ׁAs
void GameField::jyuryoku_check() 
{
    int wkflg ;
	syori_flg = false;
	int i,j;

	for (i=1;i<=mainx;i++){

		jyuryoku_count[i]= 99;
        wkflg=0;

		for (j=1;j<=mainy+2;j++) {
			if ((tumiage_chr[i][j] == 0 ) && (wkflg == 0 )) {
				wkflg = j;// wkflg͏߂ċ̃Lꏊ
			}
			 // 󒆂̃L
			if (( tumiage_chr[i][j] != 0) && (wkflg != 0) ) {

				jyuryoku_count[i] = wkflg;
				syori_flg = true;
                dropSoundFlag = true;

			}
		}
	}

    // ACẽ`FbN
    for (i=1;i<=mainx;i++) {
       for (j=1;j<=mainy+1;j++){

            if ((tumiage_chr[i][j] >= 10 ) && (tumiage_chr[i][j] <= 15 )) {
                itemRtn(i,j);
                syori_flg = true;
            }

        }
    }

	if (syori_flg == false)  {  // ׂĂ̋ɕĂȂ

        // ĕ`
        sysAdapter->drawBackgroundAndStackedCharacter(this,true);

        sysAdapter->refreshImageMain(getID());

   		checkCharactersGathering();   //  narabicheck.cpp



        if (syori_flg == true ) {   // ĂtrueȂ̂
        	waveplay("ID_WAVEDEL");
            waveflg=true;

        }
        else { // LȂ

            // ULǉ
            attacknum += getAttackCount(attackPower, killnum - wkkill, rensa);

            if (killnum >= itemCount) {

                mov->prepareItemNext();
                itemCount += itemInterval;

            }
            else {

                mov->prepareNext();

            }


            // eLXg\
            if (rensa !=0) {
            	bonus = level * 10 * (killnum - wkkill) * rensa;
            	bonusText = (IntToStr(level*10)+"~"+IntToStr(killnum-wkkill)+"~"+
            				IntToStr(rensa)+"\n="+IntToStr(bonus));
                rensaText = (IntToStr(rensa)+ " ");

                score+=bonus;

            }
            else {
            	//bonusText = "";
                if (eraseMode == 0) bonusText ="IWi\n [";
			    else bonusText = "ۂۂ\n [";

              rensaText = "";
            }


    		rensa = 0;
            wkkill=killnum;

            //
            if (dropSoundFlag) {

            	if (waveflg==true) waveplay("ID_WAVEDROP");
            	else  waveplay("ID_WAVEDROP",SND_NOSTOP);
            	dropSoundFlag = false;
            }
            calculateStackedCharacterHeight();

            // Q[I[o[̔
            if ( mov->stackedHeight[(int)(mainx+1)/2] >= mainy ) {

                isGameOver =true;

            }

        	if ((ojamanum !=0) && (isOjamaExisting == false)) {

                   if (isSousai == true) {

                        ojamaSousai();
                   }

                   fallOjamaCharacter();   // זL
                   jyuryoku_check();
        	}
        }
    }

}


// 
void GameField::itemRtn(int x,int y) // ACegp̓
{
    static bool sndFlg=false;
    static int work = 0;

    if (sndFlg == false ) {

        waveplay("ID_WAVEBREAK");
        sndFlg = true;
    }

    if (y >= 2) {

     //   tumiage_chr[x][y-2] = 10;
        tumiage_chr[x][y-1] = 10;
        tumiage_chr[x][y] = 0;
    }
    else {
        if (work == 0 ) {
            tumiage_chr[x][2] = 0;
            tumiage_chr[x][1] = 10;
            work = 1;
        }
        else if (work == 1 ) {
            tumiage_chr[x][2] = 0;
            tumiage_chr[x][1] = 11;   // ꂽC[W
            work = 2;
        }
        else if (work == 2 ) {
            tumiage_chr[x][2] = 0;
            tumiage_chr[x][1] = 0;
            work = 0;
            sndFlg = false;
        }
    }

}



// 


void GameField::calculateStackedCharacterHeight() // `FbN
{
	int i,j;
	for(i=1;i<=mainx;i++) {

		mov->stackedHeight[i]=15;  // ܂

		for (j=1;j<=mainy+4;j++) {
			if ((tumiage_chr[i][j]) == 0){ // 󔒃L𔭌
				mov->stackedHeight[i]=j-1; // ݒ
				break;
			}
		}
    }
}

// 

void GameField::rakka_syori()  // 󒆂ɕĂ񑀍L𗎉
{
	int i,j;
	for (i =1; i<=mainx ; i++) {
		for ( j=jyuryoku_count[i];j<=mainy+3;j++) {
			tumiage_chr[i][j]=tumiage_chr[i][j+1];
        }
            // hatena
    	tumiage_chr[i][mainy+4] =0;  // ŏiɂ
    }

	jyuryoku_check();
}

// 

void GameField::clearStatus()   // Q[JnȂǂɍs
{
	short i,j;
	for (i =1; i<=mainx ; i++)
		for ( j=1;j<=mainy+4;j++)
			tumiage_chr[i][j]=0;

    isGameOver =false;
    calculateStackedCharacterHeight();
    mov->eraseMoving();
    mov->prepareNext();
    attacknum = ojamanum = rensa = bonus =0;
    blinkCount = 0;
    score = 0;
    mov->preStackCount = 0;
    dropSoundFlag = false;
    if (eraseMode == 0) bonusText ="IWi\n [";
    else bonusText = "ۂۂ\n [";

    rensaText = "";

    if (players == 1 ) {

    	switch (diff1P) {
        	case 1:
            	killnum = 0;
                level = 1;
            	break;
            case 2:
            	killnum = 100;
                level = 11;
                break;
            case 3:
            	killnum = 200;
                level = 21;
                break;
            // 06/01
            case 4:
            	killnum = 300;
                level = 31;
            case 5:
            	killnum = 400;
                level = 41;
                

            default:
            	killnum = 0;
                level = 1;
		}



    }
    else {
    	killnum = 0;
    }

    itemCount = killnum + itemInterval;

    //



}

// 

void GameField::fallOjamaCharacter()    // זL
{
    int a,b,spc;


	for ( b = mainy+1; b <= mainy+3; b++) {
		spc=0;

		//ȂƂ𐔂
	    for (a = 1;a<= mainx; a++) {
	    	if (tumiage_chr[a][b] ==0) spc++;
	    }


	    if (spc <= ojamanum) { // Pi̋󔒂זLƂ
	    	for (a = 1;a<= mainx; a++) {
            	if (tumiage_chr[a][b] == 0) {
                	tumiage_chr[a][b] = OJAMA; // זL
                    ojamanum--;
                }
	    	}
	    }
	    else {
	    	while (ojamanum) {
	        	a = rand()%mainx+1;
	            if (tumiage_chr[a][b] == 0 ) {
	            	tumiage_chr[a][b] = OJAMA;
	            	ojamanum--;
	            }
	        }
	    }
	    
	}

	// P̃^C}[荞݂łQȏケ̊֐ɓȂ悤ɃtOݒu
    isOjamaExisting = true; 

    lblOjama->Caption=(IntToStr(ojamanum)); // x\XV
}

// 


GameField GameField::operator<<(GameField &from)
{

    ojamanum += from.attacknum; // 󂯎

    from.attacknum = 0;         // n̂ŏ

    lblOjama->Caption=(IntToStr(ojamanum)); // \

    return *this;
}

// ܃L̑Ȅ
void GameField::ojamaSousai()
{
    if (attacknum <= ojamanum) {
        ojamanum -= attacknum;
        attacknum = 0;
    }
    else {
        attacknum -= ojamanum;
        ojamanum = 0;
    }
}

long GameField::getAttackCount(long attackPower,long delNum,long rensa)
{
    long retnum;

    switch (attackPower) {

    case 0:
        retnum = 0;
        break;
    case 1:
        retnum = delNum * (float)(rensa / 4.0f);
        break;
    case 2:
        retnum = delNum * (float)(rensa / 3.0f);
        break;
    case 3:
        retnum = delNum * (float)(rensa / 2.0f);
        break;
    case 4:
        retnum = delNum * (float)(rensa / 1.0f);
        break;
    case 5:
        retnum = delNum * (float)(rensa * 1.5f);
        break;

    default:
        retnum = 0;
        break;
    }

    return retnum;

}



