//---------------------------------------------------------------------------

/*
  GameManager.cpp
  Q[isǗNX
  2002/07/29쐬


*/
#include <vcl.h>
#include <stdio.h>
#include <string.h>
#pragma hdrstop

#include "GameManager.h"
#include "Mainfrm.h"
#include "fHighScore.h"
#include "SystemAdapter.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

GameManager::GameManager() {
  isFirst = true;
  isTitle = true;
  isGameOver = false;
  isTitleValid = true;
  moving = new MovingCharacter(0);
  moving2 = new MovingCharacter(1);
  scd = new GameField(moving->getID(), moving);
  scd2 = new GameField(moving2->getID(), moving2);

  
}

GameManager* GameManager::getInstance() {

   if (_gm == NULL) {
     _gm = new GameManager();
   }
   return _gm;
}

void GameManager::destroy() {
   delete moving;
   delete moving2;
   delete scd;
   delete scd2;

}

void GameManager::gameStart()
{
    

    static frame = 0;

    frame++;

    sysAdapter->drawBackgroundAndStackedCharacter(scd,true);
    sysAdapter->drawBackgroundAndStackedCharacter(scd2,true);


    sysAdapter->drawBackground(scd);
    sysAdapter->drawBackground(scd2);


    int startX;
    int startY;


    startX = ((mainx * KOMA_WIDTH) - frmMain->imgStart->Width) / 2;
    //startY = imgMain->Height - frame * 30;

    startY = ((frame * frame) - (14 * frame)) * 5 + frmMain->imgMain->Height - 10;
    //wIɌ y= -x^2 + 14x


    drawing(frmMain->imgMain->Canvas,frmMain->imgStart->Canvas,startX, startY,
            frmMain->imgStart->Width, frmMain->imgStart->Height / 2);

    drawing(frmMain->imgMain2->Canvas,frmMain->imgStart->Canvas,startX, startY,
            frmMain->imgStart->Width, frmMain->imgStart->Height / 2);



    frmMain->imgMain->Refresh();
    frmMain->imgMain2->Refresh();

         ;
    if ( frame >= 10 ) {
        frame = 0;
        isFirst = false;
    }
}

///  Q[I[o[̏
void GameManager::gameOver()
{

    static frame = 0;

    frame++;

    if (frame == 1 ) {
        waveplay("ID_WAVEFLYUP");
    }

    sysAdapter->drawBackground(scd);
    sysAdapter->drawBackground(scd2);

    sysAdapter->drawStackedCharacter(scd) ;
    sysAdapter->drawStackedCharacter(scd2) ;

    int startX;
    int startY;

    startX = (frmMain->imgMain->Width - frmMain->imgGameover->Width) /2;

    startY = ((frame * frame) - (14 * frame)) * 5 + frmMain->imgMain->Height - 10;
    //wIɌ y= -x^2 + 14x


    if (players == 1 ) {

        // Plp
        // `
        drawing(frmMain->imgMain->Canvas,frmMain->imgGameover->Canvas,
                startX, startY,frmMain->imgGameover->Width,
                frmMain->imgGameover->Height / 2);


    }
    else { // Qlp

        if (scd->isGameOver == true ) { // Qo
            drawing(frmMain->imgMain->Canvas,frmMain->img2PLose->Canvas,
                    startX, startY,frmMain->img2PLose->Width,
                    frmMain->img2PLose->Height / 2);

            drawing(frmMain->imgMain2->Canvas,frmMain->img2PWin->Canvas,
                    startX, startY,frmMain->img2PWin->Width,
                    frmMain->img2PWin->Height / 2);

        }
        else {                      // Po
            drawing(frmMain->imgMain->Canvas,frmMain->img2PWin->Canvas,
              startX, startY,frmMain->img2PWin->Width,
              frmMain->img2PWin->Height / 2);

            drawing(frmMain->imgMain2->Canvas,frmMain->img2PLose->Canvas,
              startX, startY,frmMain->img2PLose->Width,
              frmMain->img2PLose->Height / 2);

        }


    }

    // ĕ`
    frmMain->imgMain->Refresh();
    frmMain->imgMain2->Refresh();

         ;
    if ( frame >= 10 ) {

        waveplay("ID_WAVEBREAK");

        frame = 0;
        isGameOver = false;
        frmMain->tmrMain->Enabled =false;
        frmMain->tmrJoystick->Enabled = false;

        if (players == 1) {             // Po[h

            // nCXRÃ`FbN
            int i;
            int rank = 0,work;
            short emode;
            emode = eraseMode;

        for (i=5;i>=1;i--) {

            	if ( scd->score > high2[emode][i-1]->score ) {

                	work = high2[emode][i-1]->score;
                    high2[emode][i-1]->score = scd->score;

                    if (i != 5 ) high2[emode][i]->score = work;

                    work = high2[emode][i-1]->level;
                    high2[emode][i-1]->level = scd->level;
                    if (i != 5 ) {
                    	high2[emode][i]->level = work;
                        high2[emode][i]->name = high2[emode][i-1]->name;
                    }
                    rank = i;
                }
                else {
                	break;
                }
            }

            if ( rank > 0 ) {  //Tʈȓ

                frmHighScore = new TfrmHighScore(frmMain);


                //GfBbg{bNXLÖʒuɈړ
                frmHighScore->Edit1->Visible = true;
                frmHighScore->Edit1->Top = frmHighScore->lblName[rank]->Top;
                frmHighScore->Edit1->Left = frmHighScore->lblName[rank]->Left;
                frmHighScore->lblName[rank]->Visible = false;
                frmHighScore->Edit1->BringToFront();

                frmHighScore->emode = emode;

				frmHighScore->ShowModal();

                high2[emode][rank-1]->name = frmHighScore->Edit1->Text;

    			delete frmHighScore;

        	}

         }
         else if (scd->isGameOver == true ) {
            StretchBlt(sysAdapter->imageMain[scd->getID()]->Canvas->Handle,0,0,
                       mainx * KOMA_WIDTH, mainy * KOMA_HEIGHT,
            		   frmMain->imgGray->Canvas->Handle,0,0,32,32,SRCAND);
            sysAdapter->refreshImageMain(scd->getID());


            scd2->wins++;
            frmMain->lblWin2->Caption = scd2->wins;

        }
        else {

        	StretchBlt(sysAdapter->imageMain[scd2->getID()]->Canvas->Handle,0,0,
                       mainx * KOMA_WIDTH, mainy * KOMA_HEIGHT,
            			frmMain->imgGray->Canvas->Handle,0,0,32,32,SRCAND);
            sysAdapter->refreshImageMain(scd2->getID());



            scd->wins++;
            frmMain->lblWin1->Caption = scd->wins;
        }

        if ( (players == 1) && (isRegistered == false)) {
            static short playcount = 4;
            if (playcount == 0) {

            	Application->MessageBox("̃Q[\tg̓VFAEFAłB\nȏyޏꍇ́A[U[o^KvłB\nCɓ܂烆[U[o^Ђ肢܂B"
            	,"Caution",(MB_OK | MB_ICONINFORMATION));
         		Application->Terminate();
            }
            else if(playcount <= 2) {
        	    Application->MessageBox("̃Q[\tg̓VFAEFAłB\nCɓ܂烆[U[o^Ђ肢܂B"
                    ,"Caution",(MB_OK | MB_ICONINFORMATION));
         	}
            playcount--;

        }

        else if ((scd->wins + scd2->wins >= 3) && (isRegistered == false) ) {
        	Application->MessageBox("̃Q[\tg̓VFAEFAłB\nȏyޏꍇ́A[U[o^KvłB\nCɓ܂烆[U[o^Ђ肢܂B"
            ,"Caution",(MB_OK | MB_ICONINFORMATION));
         	Application->Terminate();
        }

        scd->clearStatus();  // 
        scd2->clearStatus();
        frmMain->mnuPause->Enabled = false;
        frmMain->mnuOption->Enabled = true;
        frmMain->mnuHelp->Enabled = true;
    }

}
// X^[g̏
void GameManager::restart()
{

    // NA
    scd->clearStatus();
    scd2->clearStatus();

    // |[Y
    frmMain->mnuPause->Enabled = true;
    frmMain->mnuPause->Checked = false;
    frmMain->tmrMain->Enabled = true;
    frmMain->tmrJoystick->Enabled = true;
    frmMain->Caption= Application->Title ;

    frmMain->modeSetting();

    startTime = GetTickCount();
    isFirst = true;

}
// ||||||||||||||||||||||||||||||||||||||
// ||||||||||||||||||||||||||||||||||||||
//      C^C}[
// ||||||||||||||||||||||||||||||||||||||
// ||||||||||||||||||||||||||||||||||||||

/*  C^C}[荞 */
void  GameManager::mainTimer()
{
  //  int i;
  	if ( isTitle == true && false ) {
        // ^Cg
        frmMain->Caption = "^Cg";
        frmMain->tmrMain->Enabled = false;
        frmMain->tmrJoystick->Enabled = false;

        return;
    }
    else if ( isFirst == true ) {
        gameStart();
        return;
    }
    else if ( isGameOver == true ) {
        gameOver();
        return;
    }

    // Ԑ
    // isRegistered = true; // p

    if ( isRegistered == false ) {
       frmMain->checkUnregisteredLimitation();
    }

    joyState[0].check2();
    joyState[1].check2();



	//   PoivC[j̏   

    if (scd->blinkCount > 0) {

    	scd->blinkCount--;;;  // _ł邾
        scd->isRefresh = true;

        if (scd->blinkCount == 0) {
         	scd->rakka_syori();
        }

        joyState[0].flgClear();
        if (players == 1) joyState[1].flgClear();

    }
    else if (scd->syori_flg) {  // RȂ(s\)

    	// `
        scd->rakka_syori();
        scd->isRefresh = true;
        joyState[0].flgClear();
        if (players == 1) joyState[1].flgClear();


    }
    else // 쒆Ȃ
    {
        if (players == 1 ) {
             if (moving->preStackCount == 0) {

        		moving->down(moving->down1p);
            }
        }
        else {
            if (moving->preStackCount == 0) {
				moving->down(); // 쒆̃R}̗
            }
        }


        scd->isOjamaExisting = false;
        // L[`FbN
	    if (GetAsyncKeyState(sousaKeyCode[0][0]) || joyState[0].LeftMove) moving->move(MovingCharacter::LEFT);
	    if (GetAsyncKeyState(sousaKeyCode[0][1]) || joyState[0].RightMove) moving->move(MovingCharacter::RIGHT);
	    if (GetAsyncKeyState(sousaKeyCode[0][2]) || joyState[0].Drop) moving->move(MovingCharacter::DROP);

	    if (GetAsyncKeyState(sousaKeyCode[0][3]) || joyState[0].LeftTurn) moving->turn(MovingCharacter::LEFT);
	    if (GetAsyncKeyState(sousaKeyCode[0][4]) || joyState[0].RightTurn) moving->turn(MovingCharacter::RIGHT);
	    if (GetAsyncKeyState(sousaKeyCode[0][5]) || joyState[0].QuickTurn) moving->quickturn();

        joyState[0].flgClear();


        // lp̂Ƃ͂QõL[łB
        if (players == 1 ) {
                // L[`FbN
	    if (GetAsyncKeyState(sousaKeyCode[1][0]) || joyState[1].LeftMove) moving->move(MovingCharacter::LEFT);
	    if (GetAsyncKeyState(sousaKeyCode[1][1]) || joyState[1].RightMove) moving->move(MovingCharacter::RIGHT);
	    if (GetAsyncKeyState(sousaKeyCode[1][2]) || joyState[1].Drop) moving->move(MovingCharacter::DROP);

	    if (GetAsyncKeyState(sousaKeyCode[1][3]) || joyState[1].LeftTurn) moving->turn(MovingCharacter::LEFT);
	    if (GetAsyncKeyState(sousaKeyCode[1][4]) || joyState[1].RightTurn) moving->turn(MovingCharacter::RIGHT);
	    if (GetAsyncKeyState(sousaKeyCode[1][5]) || joyState[1].QuickTurn) moving->quickturn();

        	joyState[1].flgClear();


        }

         // ĂR}ςݏグꂽ`FbN
        if ( moving->isStacked() == true ) {

            moving->preStackCount--;

            if (moving->preStackCount <= 0) {

            	moving->slideCount = 0;
        		scd->isRefresh = true;
        		scd->pileup();
            }
        }
	}


	//  QoiEvC[j̏ 

    if (players == 2) {

         //
    	if (scd2->blinkCount > 0) {

          scd2->blinkCount--;;;  // _ł邾
          scd2->isRefresh = true;

          joyState[1].flgClear();


        } else if (scd2->syori_flg) {  // RȂ

            scd2->isRefresh = true;
            scd2->rakka_syori(); 	// 
            joyState[1].flgClear();


        }
        else  // 쒆Ȃ
        {
            moving2->down();  // 쒆̃R}̗

            scd2->isOjamaExisting = false;

            // L[`FbN
            if (GetAsyncKeyState(sousaKeyCode[1][0]) || joyState[1].LeftMove) moving2->move(MovingCharacter::LEFT);
            if (GetAsyncKeyState(sousaKeyCode[1][1]) || joyState[1].RightMove) moving2->move(MovingCharacter::RIGHT);
            if (GetAsyncKeyState(sousaKeyCode[1][2]) || joyState[1].Drop) moving2->move(MovingCharacter::DROP);

            if (GetAsyncKeyState(sousaKeyCode[1][3]) || joyState[1].LeftTurn) moving2->turn(MovingCharacter::LEFT);
            if (GetAsyncKeyState(sousaKeyCode[1][4]) || joyState[1].RightTurn) moving2->turn(MovingCharacter::RIGHT);
            if (GetAsyncKeyState(sousaKeyCode[1][5]) || joyState[1].QuickTurn) moving2->quickturn();

            joyState[1].flgClear();


             // ĂR}ςݏグꂽ`FbN
            if ( moving2->isStacked() == true ) {

                moving2->preStackCount--;

                if (moving2->preStackCount <= 0) {

                    moving2->slideCount = 0;
                    scd2->isRefresh = true;
                    scd2->pileup();
                }
            }


        }

    }


    sysAdapter->drawBackgroundAndStackedCharacter(scd,false);


    sysAdapter->drawMovingCharacter(moving);

    if (players == 2) {

        sysAdapter->drawBackgroundAndStackedCharacter(scd2,true);

    sysAdapter->drawMovingCharacter(moving2);

        // U

    	*(scd) << *(scd2); // UL𑗂
    	*(scd2) << *(scd);

    }

    sysAdapter->setLabelRemoved(0,scd->killnum);
    sysAdapter->setLabelRemoved(1,scd2->killnum);



    // PvC[̎̏
    if (players == 1) {


        sysAdapter->setSingleLabelRemoved(scd->killnum);

        scd->level = (scd->killnum/10)+1;
        sysAdapter->setSingleLabelLevel(scd->level);


        if (scd->level > MAXSPEED/2 ) {
        	moving->down1p = MAXSPEED;
        }
        else {
        	moving->down1p = 2 * scd->level;
        }

        sysAdapter->setSingleLabelChain(scd->rensaText.c_str());

        char scoreStr[255];
        sprintf(scoreStr,"Score\n%ld",scd->score);


       sysAdapter->setSingleLabelScore(scoreStr);


        sysAdapter->setSingleLabelBonus(scd->bonusText.c_str());

    }


    //  Q[I[o[̏
    if ((scd->isGameOver == true ) || (scd2->isGameOver == true ) ) {

        frmMain->tmrJoystick->Enabled = false;

        endTime= GetTickCount();

        isGameOver = true;
     }

    frmMain->imgMain->Refresh();
    frmMain->imgMain2->Refresh();

}



