//---------------------------------------------------------------------------
#include <vcl.h>

#pragma hdrstop

#include "Common.h"
#include "GameField.h"
#include "NarabiCheck.h"
//---------------------------------------------------------------------------


#define BLINKFRAMES 4


//  L̕т`FbN
void GameField::checkCharactersGathering()
{

    if (rensa==0) wkkill= killnum;

    if (eraseMode == 0) {
    // IWi[h
        syori_flg =  checkGatheredOriginalMode();
    }
    else {
    // ՂՂ惂[h
        syori_flg =  checkGatheredPuyoMode();
    }

    // syori_flg = true ̂ƂL
    if (syori_flg == true ) {
    	blinkCount = BLINKFRAMES;
       rensa++; // ĂΘAJEgAbv
       checkAdjacentOjamaCharacter();
    }

}

//---------------------------------------------------------------------
void GameField::checkAdjacentOjamaCharacter() {
    //  זL
    int i,j;

    for (i=1;i<=mainx;i++)
     for (j=1;j<=mainy+4;j++) {

        if (syometu_flg[i][j] == true && tumiage_chr[i][j] != OJAMA) {

            // ׂȂ΂זL   00/06/01
            if (i > 1 && tumiage_chr[i-1][j] == OJAMA)
            	 syometu_flg[i-1][j]= true;
            if (i < mainx && tumiage_chr[i+1][j] == OJAMA)
            	 syometu_flg[i+1][j]= true;
            if (j > 1 && tumiage_chr[i][j-1] == OJAMA)
            	syometu_flg[i][j-1]= true;
            if (j < mainy +4 && tumiage_chr[i][j+1] == OJAMA)
            	syometu_flg[i][j+1]= true;
        }
     }

}

// IWi[hł̕є`FbN
bool GameField::checkGatheredOriginalMode() {

   bool result = false;

    int i,j,k;
    int work;

    // 
    for (j=1;j<=mainy+2;j++)
     for (i=1;i<=mainx-2;i++) {
        work = tumiage_chr[i][j];

        if ( ( work == tumiage_chr[i+1][j] ) && (work == tumiage_chr[i+2][j])
           && ( work!= 0 ) && (work != OJAMA ) ) {
             result = true;
             for (k=0;k<=2;k++)
                syometu_flg[i+k][j] = true;

             while (true) {
             	if (i+k > mainx) {
					break;
		        }
                else if (work == tumiage_chr[i+k][j] ){
                    syometu_flg[i+k][j] =true;
                    k++;
                }
                else break;
             }
        }
     }


    // c
    for (j=1;j<=mainy;j++)
     for (i=1;i<=mainx;i++) {
        work = tumiage_chr[i][j];

        if ( ( work == tumiage_chr[i][j+1] ) && (work == tumiage_chr[i][j+2])
           && ( work!= 0 ) && (work != OJAMA ) ) {
             result = true;
             for (k=0;k<=2;k++)
                syometu_flg[i][j+k] = true;

             while (1) {
                if (work == tumiage_chr[i][j+k] ){
                    syometu_flg[i][j+k] =true;
                    k++;
                }
                else break;
             }
        }
     }


    // ΂ߕт̔iォEj
    for (j=3;j<=mainy;j++)
     for (i=1;i<=mainx;i++) {
        work = tumiage_chr[i][j];

        if ( ( work == tumiage_chr[i+1][j-1] ) && (work == tumiage_chr[i+2][j-2] )
           && ( work!= 0 ) && (work != OJAMA ) ) {
             result = true;
             for (k=0;k<=2;k++)
                syometu_flg[i+k][j-k] = true;

             while (1) {
                if (work == tumiage_chr[i+k][j-k] ) {
                    syometu_flg[i+k][j-k] =true;
                    k++;
                }
                else break;
             }
        }
     }


    // ΂ߕт̔iEォ獶j
    for (j=1;j<=mainy;j++)
     for (i=1;i<=mainx-2;i++) {
        work = tumiage_chr[i][j];

        if ( ( work == tumiage_chr[i+1][j+1] ) && (work == tumiage_chr[i+2][j+2] )
           && ( work!= 0 ) && (work != OJAMA ) ) {
             result = true;
             for (k=0;k<=2;k++)
                syometu_flg[i+k][j+k] = true;

             while (1) {
                if (work == tumiage_chr[i+k][j+k]) {
                    syometu_flg[i+k][j+k] =true;
                    k++;
                }
                else break;
             }
        }
     }

     return result;
}

bool GameField::checkGatheredPuyoMode() {
    bool result=false;
    int i,j;
    int work;

	int i2, j2;
	//int x,y;

	for (i=1;i<mainx+1;i++) {
      for (j=1;j<mainy+5;j++) {

	    for (i2=0;i2<mainx+1;i2++) {
	      for (j2=0;j2<mainy+5;j2++) {
	        checkZumi[i2][j2]= false;
		  }
        }

	    work = tumiage_chr[i][j];
	    checkZumi[i][j]= true;
	    puyoCount = 1;

	    if (work != 0 && work != OJAMA) {

          isCharacterSameKind(i+1,j,work);
	      isCharacterSameKind(i,j+1,work);
	      isCharacterSameKind(i-1,j,work);
	      isCharacterSameKind(i,j-1,work);
        }

        if (puyoCount >= 4) {
          result = true;

		  for (i2=0;i2<=mainx;i2++) {
		    for(j2=0;j2<mainy+4;j2++) {

		      if (checkZumi[i2][j2] == true) {
                syometu_flg[i2][j2] = true;
              }
            }
          }
        }


	 }
   }

   return result;

}

// w肳ꂽꏊ̃Lkindǂ
bool GameField::isCharacterSameKind(int x,int y,int kind)
{

	if ( (kind == tumiage_chr[x][y]) &&
         (checkZumi[x][y] == false) ) {

		puyoCount++;
		checkZumi[x][y]=true;

		if (x < mainx+1) isCharacterSameKind(x+1,y,kind); // ẼׂL`FbN
        if (y < mainy+3) isCharacterSameKind(x,y+1,kind);
        if (x > 1) isCharacterSameKind(x-1,y,kind);
        if (y > 1) isCharacterSameKind(x,y-1,kind);

        return true;

	}
	else {
        return false;
	}

}

