//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "fHighScore.h"
#include "Common.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TfrmHighScore *frmHighScore;


//---------------------------------------------------------------------------
__fastcall TfrmHighScore::TfrmHighScore(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TfrmHighScore::FormCreate(TObject *Sender)
{
    Color = clBlack;

    lblRank[0] = Label1;
    lblRank[1] = Label2;
    lblRank[2] = Label3;
    lblRank[3] = Label4;
    lblRank[4] = Label5;
    lblRank[5] = Label6;
    lblScore[0] = Label7;
    lblScore[1] = Label8;
    lblScore[2] = Label9;
    lblScore[3] = Label10;
    lblScore[4] = Label11;
    lblScore[5] = Label12;
    lblLevel[0] = Label13;
    lblLevel[1] = Label14;
    lblLevel[2] = Label15;
    lblLevel[3] = Label16;
    lblLevel[4] = Label17;
    lblLevel[5] = Label18;
    lblName[0] = Label19;
    lblName[1] = Label20;
    lblName[2] = Label21;
    lblName[3] = Label22;
    lblName[4] = Label23;
    lblName[5] = Label24;

    rdMode[0] = radio1;
    rdMode[1] = radio2;


    int i;
    for ( i=0;i<6;i++) {

    	lblRank[i]->Color = clBlack;
    	lblScore[i]->Color = clBlack;
    	lblLevel[i]->Color = clBlack;
    	lblName[i]->Color = clBlack;

        lblRank[i]->SetBounds(20,30+i*32,40,16);
        lblScore[i]->SetBounds(58,30+i*32,105,16);
        lblLevel[i]->SetBounds(176,30+i*32,57,16);
        lblName[i]->SetBounds(256,30+i*32,129,16);

    }

    emode = -1;

    // 傫ݒ
    this->ClientWidth = 416;

    this->ClientHeight = 256;
    //this->ClientHeight = 288;



    // _~[̃GfBbg{bNXʊOɉB
    edtDummy->Left = this->Width + 10;
    edtDummy->Top = this->Height + 10;

    rdMode[0]->Top = 220;
    rdMode[1]->Top = 220;
    rdMode[eraseMode]->Checked = true;


    for ( i = 0;i<5;i++) {

    	lblScore[i+1]->Caption = IntToStr(high2[eraseMode][i]->score);
        lblName[i+1]->Caption = high2[eraseMode][i]->name;
        lblLevel[i+1]->Caption = IntToStr(high2[eraseMode][i]->level);


    }

}
//---------------------------------------------------------------------------



void __fastcall TfrmHighScore::FormActivate(TObject *Sender)
{
    short i;
    if (emode != -1) {

        rdMode[0]->Enabled = false;
        rdMode[1]->Enabled = false;
        rdMode[emode]->Enabled = true;

        for ( i = 0;i<5;i++) {

            lblScore[i+1]->Caption = IntToStr(high2[emode][i]->score);
            lblName[i+1]->Caption = high2[emode][i]->name;
            lblLevel[i+1]->Caption = IntToStr(high2[emode][i]->level);

        }
    }

}
//---------------------------------------------------------------------------


void __fastcall TfrmHighScore::FormPaint(TObject *Sender)
{
//̃K̕`

    int work,i;
    work = ClientWidth / 32;
    for (i = 0; i<=work ; i++ ) {


        BitBlt(this->Canvas->Handle, (i * 32), 0, 32, 16,
               imgRenga->Canvas->Handle, 0, 0, SRCCOPY); //

        BitBlt(this->Canvas->Handle, (i * 32), ClientHeight - 16, 32, 16,
                imgRenga->Canvas->Handle, 0, 0, SRCCOPY); //

    }

    work = ClientHeight / 32;

    for ( i = 0; i<=work ; i++) {

    	BitBlt(this->Canvas->Handle, 0, (i * 32), 16, 32,
               	imgRenga->Canvas->Handle, 0, 0, SRCCOPY); //

    	BitBlt(this->Canvas->Handle, ClientWidth - 16, (i * 32), 16, 32,
               	imgRenga->Canvas->Handle, 0, 0, SRCCOPY); //

    }

 
	
}
//---------------------------------------------------------------------------

void __fastcall TfrmHighScore::FormClick(TObject *Sender)
{
    // nCXRA\Ȃ
	if ( Edit1->Visible == false ) Close();

    //Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmHighScore::FormKeyDown(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
    if ( Edit1->Visible == false && Key == VK_SPACE ) Close();


}
//---------------------------------------------------------------------------
void __fastcall TfrmHighScore::Edit1KeyPress(TObject *Sender, char &Key)
{
	if (Key == VK_RETURN ) {

        edtDummy->Visible = true;
        edtDummy->SetFocus();
        edtDummy->Visible = false;
        Close();

    }

}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TfrmHighScore::radioClick(TObject *Sender)
{
//
  const String defaultCaption = "nCXRA(1Player)";



  if (rdMode[0]->Enabled == false || rdMode[1]->Enabled == false) {
     return;
  }

  short i;
  if (rdMode[0]->Checked == true) {

        for ( i = 0;i<5;i++) {
    	lblScore[i+1]->Caption = IntToStr(high2[0][i]->score);
        lblName[i+1]->Caption = high2[0][i]->name;
        lblLevel[i+1]->Caption = IntToStr(high2[0][i]->level);
        }
  }
  else {

        for ( i = 0;i<5;i++) {
        lblScore[i+1]->Caption = IntToStr(high2[1][i]->score);
        lblName[i+1]->Caption = high2[1][i]->name;
        lblLevel[i+1]->Caption = IntToStr(high2[1][i]->level);
        }
  }

  Caption = defaultCaption + " - " + ((TRadioButton *)Sender)->Caption;

}
//---------------------------------------------------------------------------


