//---------------------------------------------------------------------------
#ifndef GameManagerH
#define GameManagerH

#include "Common.h"

#include "MovingCharacter.h"
#include "GameField.h"
//#include "Mainfrm.h"
//---------------------------------------------------------------------------
class GameManager {

public:
   GameManager();
   static GameManager *_gm;
   static GameManager* getInstance();
   void destroy();

   void gameStart();
   void gameOver();
   void restart();
   void mainTimer();

   bool isFirst; // Q[̍ŏ
   bool isTitle; // ^Cg\ǂ
   bool isGameOver; // Q[I[o[
   bool isTitleValid;
   unsigned long startTime;
   unsigned long endTime;
   MovingCharacter *moving;
   GameField *scd;
   MovingCharacter *moving2;
   GameField *scd2;


};



#endif



