//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#pragma hdrstop

#include "MovingCharacter.h"
#include "SystemAdapter.h"
#include "MainFrm.h"
//---------------------------------------------------------------------------



MovingCharacter::MovingCharacter(int id_num)  // RXgN^
{
    id = id_num;
	charkinds = 4; // ~Ă

	kind1 = rand()% charkinds + 1;
	kind2 = rand()% charkinds + 1;
	next1 = rand()% charkinds + 1;
	next2 = rand()% charkinds + 1;
    
    downspeed = 2;

    int i;  
    for (i=1;i<=mainx;i++)
    	stackedHeight[i] = 0;  //  

    stackedHeight[0] = stackedHeight[mainx+1] = 99;   // Eɕǂ

    
}


void MovingCharacter::down(int speed,bool isNatural)   //  
{
    if (speed == 0) speed = downspeed; // ȗ̎


    if (isItem(kind1) == false) {  // ACeȊO

        y1+=speed;
        y2+=speed;
    }
    else if ( isNatural == false ) {

        y1+=MAXSPEED -2;
        y2+=MAXSPEED -2;
    }
    else {
        y1+=2;
        y2+=2;
    }



    calculateXYPosition();

    if ( y1 > (mainy - stackedHeight[posx1] ) * KOMA_HEIGHT )
        y1 = (mainy - stackedHeight[posx1] ) * KOMA_HEIGHT;
    if ( y2 > (mainy - stackedHeight[posx2] ) * KOMA_HEIGHT )
        y2 = (mainy - stackedHeight[posx2] ) * KOMA_HEIGHT;       
}


int MovingCharacter::move(int way) // Eړhbv

{
    if (preStackCount != 0) {
     	xyreset();
    }
	calculateXYPosition();

    if (preStackCount != 0 ) {
    	posy1++;
        posy2++;
    }


	switch (way) {
		case LEFT:
			if ((x1 < x2) && (posy1 > (stackedHeight[posx1-1] +1)) ) {
				x1 -=KOMA_WIDTH;
				x2 -=KOMA_WIDTH;
                preStackCount = 0;
			}
			else if ( ( x2 < x1) && (posy2 > (stackedHeight[posx2-1] +1)) ) {
				x1 -=KOMA_WIDTH;
				x2 -=KOMA_WIDTH;
                preStackCount = 0;
			}
			// cт̎
			else if ( ( posy1 > stackedHeight[posx1-1]+1) &&
						( posy2 >stackedHeight[posx2-1]+1) ) {
				x1 -=KOMA_WIDTH;
				x2 -=KOMA_WIDTH;
                preStackCount = 0;
			}

			break;

		case RIGHT:
			if ((x1 > x2) && (posy1 > (stackedHeight[posx1+1] +1)) ) {
				x1 +=KOMA_WIDTH;
				x2 +=KOMA_WIDTH;
                preStackCount = 0;
			}
			else if ( ( x2 > x1) && (posy2 > (stackedHeight[posx2+1] +1)) ) {
				x1 +=KOMA_WIDTH;
				x2 +=KOMA_WIDTH;
                preStackCount = 0;
			}
			// cт̎
			else if ( ( posy1 > stackedHeight[posx1+1]+1) &&
						( posy2 >stackedHeight[posx2+1]+1) ) {
				x1 +=KOMA_WIDTH;
				x2 +=KOMA_WIDTH;
                preStackCount = 0;
			}

			break;
        case DROP:

        	if (preStackCount != 0) {
            	preStackCount = 1;
                break;
            }

        	int dropspeed = MAXSPEED;

        	if  ( (dropspeed > downspeed || isItem(kind1)) && players == 2) {
                down(dropspeed-downspeed, false);

            }
            else if ((dropspeed > down1p || isItem(kind1)) && players == 1 ){

            	down(dropspeed-down1p, false);

            }

            break;
		}

	return 0;
}


//  L]
int MovingCharacter::turn(int course)
{

    if (kind2 == 0) return 1;

    if (preStackCount != 0) {
     	xyreset();
    }

	calculateXYPosition();
	switch (course) {
		case LEFT:     // ]ivj
			if (x2 > x1) {
				x2 =x1;
				y2=y1-KOMA_HEIGHT;
                preStackCount = 0;
			}
			else if (x1 > x2) {
				if (posy1 > stackedHeight[posx1]+1) {           //LQP̉
					x2 = x1;
					y2 = y1 + KOMA_HEIGHT;
                    preStackCount = 0;
				}
				else {
					x1 = x2;
					y1 = y2 - KOMA_HEIGHT;
                    preStackCount = 0;
				}
			}
			else if (y2 > y1) {
				if (posy1 > stackedHeight[posx1+1]+1) {
					x2 = x1 +KOMA_WIDTH;
					y2 = y1;
                    preStackCount = 0;
				}
				else if (posy2 > stackedHeight[posx2-1]+1) {
	                x1 = x2-KOMA_WIDTH;
	                y1 = y2;
                    preStackCount = 0;
	            }
	            else if (quick) {
                	quickturn();
                    quick = !quick;
                }
                else quick = !quick;
			}
			else {  // y1 > y2
				if (posy1 > stackedHeight[posx1-1] +1){
					x2 = x1-KOMA_WIDTH;
					y2 = y1;
                    preStackCount = 0;
				}
				else if (posy2 > stackedHeight[posx2+1] +1 )
				{
                	y2 = y1;
					x1 = x2 +KOMA_WIDTH;
                    preStackCount = 0;
				}
	            else if (quick) {
                	quickturn();
                    quick = !quick;
                }
                else quick = !quick;
			}
			break;
		// E]
		case RIGHT:
			if (x2 > x1) {
				if (posy1 > stackedHeight[posx1]+1 )  {//posy1 > taka
					x2 = x1;
					y2=y1+KOMA_HEIGHT;
                    preStackCount = 0;
				}
				else {
					x1 =x2;
					y1=y2-KOMA_HEIGHT;
                    preStackCount = 0;
				}
			}
			else if (x1 > x2) {
				x2=x1;
				y2=y1 -KOMA_HEIGHT;
                preStackCount = 0;
			}
			else if (y2 > y1) {
				if (posy1 >stackedHeight[posx1-1]+1) {
					x2=x1-KOMA_WIDTH;
					y2=y1;
                    preStackCount = 0;
				}
				else if ( posy2 > stackedHeight[posx1+1]+1) {
					x1 = x2+KOMA_WIDTH;
					y1=y2;
                    preStackCount = 0;
				}
                else if (quick) {
                quickturn();
                quick = !quick;
                preStackCount = 0;
                }
                else quick = !quick;

			}
			else {
				if (posy1 > stackedHeight[posx1+1]+1) {
					x2 = x1 +KOMA_WIDTH;
					y2=y1;
                    preStackCount = 0;
				}
				else if (posy2 > stackedHeight[posx2-1]+1 ) {
					y2 = y1;
					x1 = x2-KOMA_WIDTH;
                    preStackCount = 0;

				}
            	else if (quick) {
                	quickturn();
                    quick = !quick;
                }
                else quick = !quick;

			}
			break;
	}
  return 0;
}


void MovingCharacter::quickturn()  //  NCbN^[
{

    if (kind2 == 0) return;

	int work;

    work = x1;
    x1 = x2;
    x2 = work;

    work = y1;
    y1 = y2;
    y2 = work;
}



// ĨLɎグ
void MovingCharacter::eraseMoving()
{

	x1= x2 =((mainx+1)/2-1)*KOMA_WIDTH;
	y1=-KOMA_HEIGHT;
	y2=-KOMA_HEIGHT*2;
	calculateXYPosition();

}



// ̋̏
void MovingCharacter::prepareNext()
{
	kind1=next1;
	kind2=next2;
	next1=rand()% charkinds + 1;
	next2=rand()% charkinds + 1;


    sysAdapter->drawNextArea(this);
    sysAdapter->drawMovingCharacter(this);
}

void MovingCharacter::prepareItemNext()
{
	kind1=next1;
	kind2=next2;
	next1=10;
	next2=0;


    sysAdapter->drawNextArea(this);
    sysAdapter->drawMovingCharacter(this);
}


bool MovingCharacter::isStacked() // ς܂ꂽǂ
{
    calculateXYPosition();

	if ((posy1 <= stackedHeight[posx1]+1) || (posy2 <= stackedHeight[posx2]+1) ) {

        if (preStackCount == 0) {

        	if (slideCount < 7) {

            slideCount++;
    		preStackCount = 3;
            waveplay("ID_WAVEDROP");

            xyreset();

            } else {
            	preStackCount = 1;
            }



        }
        
    	return true;
    }

    return false;
}


void MovingCharacter::calculateXYPosition()  //       posx,posy߂
{
	posx1 = x1 / KOMA_WIDTH +1;
	posx2 = x2 / KOMA_WIDTH +1;

	posy1 = mainy - ( ( (y1+(KOMA_HEIGHT*3)) / KOMA_HEIGHT)-3);  //̐؂グN
	posy2 = mainy - ( ( (y2+(KOMA_HEIGHT*3)) / KOMA_HEIGHT)-3); //  Ȃ悤Ɉx3
                       // y / KOMA_HEIGHT Ɠ
}


void MovingCharacter::xyreset() {

	calculateXYPosition();


    if ( x1 != x2) {

    	if (stackedHeight[posx1] >= stackedHeight[posx2]) {

        	y1 =(mainy*KOMA_HEIGHT) - (stackedHeight[posx1]  * KOMA_HEIGHT) -KOMA_HEIGHT;
        	y2 = y1;


        }
        else {
       		y2 =(mainy*KOMA_HEIGHT) - (stackedHeight[posx2]  * KOMA_HEIGHT) -KOMA_HEIGHT;
        	y1 = y2;


        }


    }
	else if ( y1 < y2) {    //  y2

      	y2 = (mainy*KOMA_HEIGHT) - (stackedHeight[posx2]  * KOMA_HEIGHT) -KOMA_HEIGHT;
        y1 = y2 -KOMA_HEIGHT;



    }
    else if ( y1 > y2) {
    	y1 = (mainy*KOMA_HEIGHT) - (stackedHeight[posx1]  * KOMA_HEIGHT) -KOMA_HEIGHT;
        y2 = y1 -KOMA_HEIGHT;


    }

    calculateXYPosition();

}

bool MovingCharacter::isItem(int kindNo)
{
    if (kindNo >= 10 && kindNo <= 19 ) {
        return true;
    }
    else {
        return false;
    }


}


