//---------------------------------------------------------------------------
#ifndef SystemAdapterH
#define SystemAdapterH

#include "Constants.h"
#include "GameField.h"
#include "MovingCharacter.h"
//---------------------------------------------------------------------------
class SystemAdapter {

private:
    TImage ** imageCharacter;
    TImage * imageBuffer[2];
    TImage * imageNext[2];


public:
    int dummy;
    TImage * imageMain[2];
    SystemAdapter();
    virtual void setLabelRemoved(int player,int killNum);
    void setSingleLabelRemoved(int killNum);
    virtual void setSingleLabelLevel(int lv);
    void setSingleLabelBonus(char* txt);
    void setSingleLabelChain(char * txt);
    virtual void setSingleLabelScore(char * txt);
    void drawBackground(GameField *sc);   //  wî݂`
    void drawStackedCharacter(GameField *sc); // ɐςݏグꂽL`
    void drawBackgroundAndStackedCharacter(GameField * sc, bool refresh);  // wiƉɐςݏグꂽL`()
    virtual void refreshImageMain(int id_num);


    virtual void setCharacterImage(TImage ** imgChara) {
        imageCharacter = imgChara;
    }
    virtual void setMainImage(int id, TImage * img){
        imageMain[id] = img;
    }
    virtual void setBufferImage(int id, TImage * img) {
        imageBuffer[id] = img;
    }
    virtual void setNextImage(int id, TImage * img){
        imageNext[id] = img;
    }
    virtual void drawMovingCharacter(MovingCharacter * movChar);
    virtual void drawNextArea(MovingCharacter * movChar);



};



#endif
